/*
 * unity-webapps-binding-dispatcher.h
 * Copyright (C) Canonical LTD 2012
 * 
 * Author: Alexandre Abreu <alexandre.abreu@canonical.com>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#if ! defined (UNITY_WEBAPPS_BINDING_DISPATCHER_H)
#define UNITY_WEBAPPS_BINDING_DISPATCHER_H


#include "npapi-headers/headers/npapi.h"
#include "npapi-headers/headers/npfunctions.h"

#include "unity-npapi-common.h"


bool
webapps_binding_is_method_supported (const char * const name);

NPVariant
webapps_binding_dispatch_method_call (NPP instance
				      , const char * const name
				      , int argcnt
				      , const NPVariant args[]
				      , void (*logger) (const char * const s));

void
webapps_binding_for_each (void (*f) (const char * const name, UnityWebAppsNpapiMethodPtr));


#endif // UNITY_WEBAPPS_BINDING_DISPATCHER_H


