/*
 * wrapped-callback-type.h
 * Copyright (C) Canonical LTD 2012
 * 
 * Author: Alexandre Abreu <alexandre.abreu@canonical.com>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#if ! defined (WRAPPED_CALLBACK_TYPE_H)
#define WRAPPED_CALLBACK_TYPE_H

#include <glib.h>

#include "npapi-headers/headers/npapi.h"
#include "npapi-headers/headers/npfunctions.h"


// TODO should probably be more general
typedef struct wrapped_callback_t_
{
  NPObject object;

  NPObject * wrapped_callback;
  NPP instance;
    
  // 
  const gint argscnt;
  NPVariant args [0];

} wrapped_callback_t;



/**
 *
 * @param callback can be NULL
 */
NPObject * create_wrapped_callback_object_for (NPP instance, void * callback);


#endif // WRAPPED_CALLBACK_TYPE_H
