
#include <stdlib.h>

#include "unity-webapps-binding.h"
#include "unity-webapps-binding-test.h"
#include "test_common.h"
#include "wrapped-ptr-type.h"

static bool func_reached = false;
static void on_func_reached(void)
{
  func_reached = true;
}

int
unity_webapps_indicator_add_action_test(void)
{
  unity_webapps_binding_test_set_test_mode_on (on_func_reached);

  // handle argument count
  
  {
    NPTestObject
      tobject = {0};
    NPVariant
      args[0];
    
    NPVariant result = 
      unity_webapps_binding_indicator_add_action (NULL
                                              , (NPObject *) &tobject
                                              , &args[0]
                                              , sizeof(args)/sizeof(args[0]));
    
    if (!tobject.exceptioncalled || func_reached)
      {
        return 1;
      }

    func_reached = 0;
  }


  {
    NPTestObject
      tobject = {0};
    NPVariant
      args[1];
    NULL_TO_NPVARIANT(args[0]);
    NPVariant result = 
      unity_webapps_binding_indicator_add_action (NULL
                                              , (NPObject *) &tobject
                                              , &args[0]
                                              , sizeof(args)/sizeof(args[0]));
    
    if (!tobject.exceptioncalled || func_reached)
      {
        return 1;
      }

    func_reached = 0;
  }


  {
    NPTestObject
      tobject = {0};
    NPVariant
      args[2];
    NULL_TO_NPVARIANT(args[0]);
NULL_TO_NPVARIANT(args[1]);
    NPVariant result = 
      unity_webapps_binding_indicator_add_action (NULL
                                              , (NPObject *) &tobject
                                              , &args[0]
                                              , sizeof(args)/sizeof(args[0]));
    
    if (!tobject.exceptioncalled || func_reached)
      {
        return 1;
      }

    func_reached = 0;
  }


  {
    NPTestObject
      tobject = {0};
    NPVariant
      args[3];
    NULL_TO_NPVARIANT(args[0]);
NULL_TO_NPVARIANT(args[1]);
NULL_TO_NPVARIANT(args[2]);
    NPVariant result = 
      unity_webapps_binding_indicator_add_action (NULL
                                              , (NPObject *) &tobject
                                              , &args[0]
                                              , sizeof(args)/sizeof(args[0]));
    
    if (!tobject.exceptioncalled || func_reached)
      {
        return 1;
      }

    func_reached = 0;
  }


  {
    NPTestObject
      tobject = {0};
    NPVariant
      args[5];
    NULL_TO_NPVARIANT(args[0]);
NULL_TO_NPVARIANT(args[1]);
NULL_TO_NPVARIANT(args[2]);
NULL_TO_NPVARIANT(args[3]);
NULL_TO_NPVARIANT(args[4]);
    NPVariant result = 
      unity_webapps_binding_indicator_add_action (NULL
                                              , (NPObject *) &tobject
                                              , &args[0]
                                              , sizeof(args)/sizeof(args[0]));
    
    if (!tobject.exceptioncalled || func_reached)
      {
        return 1;
      }

    func_reached = 0;
  }


  // check arg types


  // check that function is reached w/ proper args
  
  {
    wrapped_void_ptr_t
      tobject = {0};
    NPVariant
      args[4];

    OBJECT_TO_NPVARIANT((NPObject*) &tobject,args[0]);
STRINGZ_TO_NPVARIANT("",args[1]);
OBJECT_TO_NPVARIANT((NPObject*) &tobject,args[2]);
OBJECT_TO_NPVARIANT((NPObject*) &tobject,args[3]);

    NPVariant result = 
      unity_webapps_binding_indicator_add_action (NULL
                                              , (NPObject *) &tobject
                                              , &args[0]
                                              , sizeof(args)/sizeof(args[0]));
    if (! func_reached)
      {
        return 1;
      }

    func_reached = 0;
  }

  return 0;
}

int main (int argc, char **argv)
{
  if (unity_webapps_indicator_add_action_test())
    {
      return 1;
    }

  return 0;
}
